#include <stdio.h>
#include <sys/ioctl.h>
#include <sys/select.h>
#include <stdlib.h>
#include <fcntl.h>
#include <time.h>
#include <errno.h>

#include <cutils/properties.h>

#include <android/log.h>
#define print_to_logcat(fmt...)\
__android_log_print(ANDROID_LOG_DEBUG, "MTK_DRV", fmt);

void readkmsg(int);

static int b_g_save_to_logcat = 0;

int main(int argc, char** argv)
{
	int handle = open("/dev/cli", O_RDWR);
	char command[200];
        char buf[PROPERTY_VALUE_MAX] = "";
    int cmd_i;

	if(argc <= 1)
	{
		printf("Usage: cli_shell \"command\"\n");
		return -1;
	}

        /* check to save logcat */
        if (property_get("mtk.cli_shell.to_logcat", buf, "0") <= 0) 
        {
            buf[0] = '\0';
        }
        if (buf[0] == '1')
        {
            printf("* Below log will also save to logcat.*\n");
            b_g_save_to_logcat = 1;
        }

	readkmsg(0);

	system("echo 0 > /proc/sys/kernel/printk");

    char c_key;
    for (cmd_i=1; cmd_i < argc; cmd_i ++)
    {
        strcpy(command, argv[cmd_i]);
        if (handle < 0)
        {
            printf("Cannot open /dev/cli");
            return -1;
	    }

	    //char c_key;
	    int len=strlen(command);
	    int i;
	    for(i=0; i < len; i++)
	    {
		    c_key = command[i];
    	    ioctl(handle, 0, &c_key);
	    }

        c_key = ' ';
        ioctl(handle, 0, &c_key);
        memset(command,0,200);
    }
	
	c_key = '\r';
	ioctl(handle, 0, &c_key);	
    c_key = '\n';
    ioctl(handle, 0, &c_key);
	close(handle);

	system("echo 7 > /proc/sys/kernel/printk");

	usleep(200*1000);
	readkmsg(1);
	return 0;
}

#define MAX_BUF_SIZE 512*1024*1024
void readkmsg(int print)
{
    char *buf = (char*)malloc(MAX_BUF_SIZE);
    int result;
    fd_set readset;

    if (buf == NULL)
    {
        return;
    }

    int fd = open("/proc/kmsg", O_RDONLY);
	struct timeval timeout = { 0, 50000 /* 5ms */ }; // If we oversleep it's ok, i.e. ignore EINTR.
    
	while(1)
    {
        do {
            FD_ZERO(&readset);
            FD_SET(fd, &readset);
            result = select(fd + 1, &readset, NULL, NULL, &timeout);
        } while (result == -1 && errno == EINTR);

        if (result > 0) {
            if (FD_ISSET(fd, &readset)) {
                int ret = read(fd, buf, MAX_BUF_SIZE-1);

                if (ret > 0) {
                    buf[ret]=0;
					if(print)
					{
						char *pch;
						pch = strtok(buf, "\n");
						while(pch != NULL)
						{
							printf("%s\n",&pch[3]);
                                                        if (b_g_save_to_logcat)
                                                        {
                                                            print_to_logcat("%s",&pch[3]);
                                                        }
							pch = strtok(NULL, "\n");
	
						}
//	                    printf("%s", buf);
					}
                }
            }

        }else if (result == 0) {
            break;
        }
    }

	free(buf);

	close(fd);
}
