#! /bin/sh
TOP=`pwd | sed 's/m-release-generic-fs/m-release-generic-fs /'|awk '{print $1}'`
PRODUCT_NAME='amai'

export LIBS="-lssl -lcrypto -lz"
export CPPFLAGS="-I${TOP}/system/core/include -I${TOP}/external/zlib -I${TOP}/external/boringssl/src/ -I${TOP}/external/boringssl/src/include --sysroot=${TOP}/prebuilts/ndk/current/platforms/android-21/arch-arm/"
export LDFLAGS="-L${TOP}/out/target/product/$PRODUCT_NAME/symbols/system/lib/ --sysroot=${TOP}/prebuilts/ndk/current/platforms/android-21/arch-arm/"
make clean

export CROSS_COMPILE=${TOP}/prebuilts/gcc/linux-x86/arm/arm-linux-androideabi-4.9/bin/arm-linux-androideabi
export CC=${CROSS_COMPILE}-gcc
export LD=${CROSS_COMPILE}-ld
export AS=${CROSS_COMPILE}-as
export AR=${CROSS_COMPILE}-ar

./configure \
--host=arm-linux-androideabi  \
--build=`uname -m`-linux \
--with-ssl \
--enable-shared \
--enable-debug \
--disable-ares \
--disable-dict \
--disable-telnet \
--disable-file \
--disable-tftp \
--disable-imap \
--disable-ftp \
--disable-pop3 \
--disable-sspi \
--disable-gopher \
--disable-smb \
--disable-smbs \
--disable-smtp \
--disable-smtps \
--disable-ntlm-wb \
--without-gnutls \
--without-libidn \
--without-librtmp \
--without-libssh2 \
--without-ntlm-wb \
--with-ca-bundle=/etc/certs/ca-bundle.crt


