
#include <stdlib.h>
#include <fcntl.h>
#include <errno.h>
#include <string.h>
#include <dirent.h>
#include <unistd.h>
#include <poll.h>
#include <utils/Log.h>
#include "cutils/properties.h"

#define LOG_NDEBUG 0
#define LOG_TAG "iwpriv_wifi_operation"

int main(void)
{
	char operation_prop_value[PROPERTY_VALUE_MAX] = {'\0'};
	char interval_prop_value[PROPERTY_VALUE_MAX] = {'\0'};
	char *argv[4]={"iwpriv","wlan0","set",0};
	char s_cmd[50] = {0};
	int i4_ret = 0;
	int iwpriv_operation_type = 0;
	int psawake_interval = 10;//default is 1s,1 unit is 100ms
	ALOGE("XXXXenter wifi iwpriv_wifi_operation \n");
	sched_yield();
    if (property_get("sys.net.iwpriv.operation", operation_prop_value, NULL) && (operation_prop_value[0] != '\0'))
    {	
    	iwpriv_operation_type = atoi(operation_prop_value);
		ALOGE("wifi iwpriv_wifi_operation is %d \n",iwpriv_operation_type);
		switch(iwpriv_operation_type)
		{
			case 1:
				argv[3] = "wow_wakeonport_enable=1";
				i4_ret = iwpriv_main(4,argv);
				ALOGE("iwpriv_wifi_operation setEnableWoapcket driver return %d \n",i4_ret);
				break;
			case 2:
				argv[3] = "wow_wakeonport_enable=0";
				i4_ret = iwpriv_main(4,argv);
				ALOGE("iwpriv_wifi_operation setDisableWoapcket driver return %d \n",i4_ret);
				break;
			case 3:
				argv[3] = "adv_wow_enable=1";
				i4_ret = iwpriv_main(4,argv);
				ALOGE("iwpriv_wifi_operation setEnablePsawake driver return %d \n",i4_ret);
				break;
			case 4:
				argv[3] = "adv_wow_enable=0";
				i4_ret = iwpriv_main(4,argv);
				ALOGE("iwpriv_wifi_operation setDisablePsawake driver return %d \n",i4_ret);
				break;
			case 5:
				if (property_get("sys.net.psawake.interval", interval_prop_value, NULL) && (interval_prop_value[0] != '\0'))
				{
					psawake_interval = atoi(interval_prop_value);
				}
     			snprintf(s_cmd, 50, "adv_wow_sleeptime=%d",psawake_interval);
     			argv[3] = s_cmd;
				i4_ret = iwpriv_main(4,argv);
				ALOGE("iwpriv_wifi_operation setPsawakeInterval %d driver return %d \n",psawake_interval,i4_ret);
				break;
			case 6:
				argv[3] = "fast_csa_enable=1";
				i4_ret = iwpriv_main(4,argv);
				ALOGE("iwpriv_wifi_operation setEnableCSA driver return %d \n",i4_ret);
				break;
			case 7:
				argv[3] = "fast_csa_enable=0";
				i4_ret = iwpriv_main(4,argv);
				ALOGE("iwpriv_wifi_operation setDisableCSA driver return %d \n",i4_ret);
				break;
			default:
				ALOGE("iwpriv_wifi_operation unknown type");
				break;
		}
	}

    
	return 0;
}


























