#ifndef _JPG_DEC_H_
#define _JPG_DEC_H_

#define MTM_HWDEC

#ifdef MTM_HWDEC

//hw don't support tile_decode
#define IS_HW_DECODE() ((cinfo->out_color_space == JCS_RGBA_8888 || cinfo->out_color_space == JCS_YV16) && (cinfo->tile_decode == FALSE))

#define HW_SUPPORT_MIN_SIZE_WIDTH  640
#define HW_SUPPORT_MIN_SIZE_HEIGHT 480
#endif

#define JPEG_HW_MAGIC_NUMBER   0x4D544B4A

typedef struct
{
    INT32       magic_number; //"MTKJ"  0x4D544B4A
    boolean     fg_force_hw_mode;
    UINT8       dest_bytes_per_pixel;
    UINT8       src_bytes_per_pixel;
    boolean     fg_hw_stop;
    boolean     fg_waiting_stop;
    UINT8       img_play_status;

    pthread_cond_t JpgStopCond ;
    pthread_mutex_t JpgStopMutex ;

    void*       HwJpgComp;

    UINT32      CBuffer;
}JPEG_HW_DECODER_T;

#define RESTART_BYTE(cinfo, action) \
       if (!(*((cinfo)->src->resync_to_restart))(cinfo,0)) \
        { action;}

#define READ_BYTE(cinfo,action)  \
             if (! (*((cinfo)->src->fill_input_buffer)) (cinfo))  \
               { action; } 


#endif
