# Copyright 2013 The Android Open Source Project
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

LOCAL_PATH:= $(call my-dir)
include $(CLEAR_VARS)

LOCAL_SRC_FILES := lights.c
LOCAL_MODULE_RELATIVE_PATH := hw
LOCAL_SHARED_LIBRARIES := liblog

DEVICE_STRING=device/$(CUSTOMER)/$(MODEL_NAME)
ANDROID_BUILD_TOP ?= .
export MTK_VMLINUX_ROOT := $(shell if [ -d $(TOP)/../../$(LINUX_ROOT_NAME) ]; then echo $(TOP)/../../$(LINUX_ROOT_NAME); fi)
ifeq "$(MTK_VMLINUX_ROOT)" ""
$(error MTK_VMLINUX_ROOT is not in $(TOP)/../../$(LINUX_ROOT_NAME))
endif

DTV_ROOT_OUTPUT ?= $(ANDROID_BUILD_TOP)/out/mediatek_linux/output

# For Partial Build
ifndef ANDROID_BUILD_ROOT
ANDROID_BUILD_ROOT := $(MTK_VMLINUX_ROOT)/android/$(ANDROID_VERSION)
MY_C_INC := $(shell find $(DTV_ROOT_OUTPUT) $(MTK_VMLINUX_ROOT)/mtk_obj -mindepth 5 -name 'c_inc')
MY_X_INC := $(shell find $(DTV_ROOT_OUTPUT) $(MTK_VMLINUX_ROOT)/mtk_obj -mindepth 5 -name 'x_inc')
$(warning MY_X_INC=$(MY_X_INC))
else
MY_C_INC := $(DTV_ROOT_OUTPUT)/$(CUSTOMER)/$(MODEL_NAME)/$(OBJECT_TYPE)/inc/c_inc
MY_X_INC := $(DTV_ROOT_OUTPUT)/$(CUSTOMER)/$(MODEL_NAME)/$(OBJECT_TYPE)/inc/x_inc
$(warning MY_X_INC=$(MY_X_INC))
endif

LOCAL_C_INCLUDES += \
    $(MY_C_INC) \
    $(MY_X_INC) \
    $(ANDROID_BUILD_TOP)/../../$(LINUX_ROOT_NAME)/custom/dev \
    $(ANDROID_BUILD_TOP)/../../$(LINUX_ROOT_NAME)/middleware/public \
    $(ANDROID_BUILD_TOP)/../../$(LINUX_ROOT_NAME)/middleware/public/svl \
    $(ANDROID_BUILD_TOP)/../../$(LINUX_ROOT_NAME)/middleware/public/inc \
    $(ANDROID_BUILD_TOP)/../../$(LINUX_ROOT_NAME)/middleware/public/cmpb

LOCAL_C_INCLUDES += $(ANDROID_BUILD_TOP)/../../$(LINUX_ROOT_NAME)/linux_core/app_if/mtal/mtal_inc
LOCAL_C_INCLUDES += $(ANDROID_BUILD_TOP)/../../$(LINUX_ROOT_NAME)/linux_core/app_if/mtal/include
LOCAL_C_INCLUDES += $(ANDROID_BUILD_TOP)/../../$(LINUX_ROOT_NAME)/linux_core/driver/linux/include

LOCAL_CFLAGS := -I$(L_CFLAGS) -DANDROID_TOOLCHAIN

ifeq "$(ANDROID_TWO_WORLDS)" "true"
LOCAL_CFLAGS += -DANDROID_TWO_WORLDS
endif

ifeq "${ANDROID_TWO_WORLDS}" "true"
LOCAL_LDFLAGS += -L$(ANDROID_BUILD_TOP)/$(DEVICE_STRING)/DTV_OUT/shares_libraries \
        -lapp_if_rpc \
        -lrpc_ipc \
        -lhandle_app \
        -lcmpb \
        -ldtv_osai \
        -lmtal \
        -lapp_if
else
LOCAL_LDFLAGS += -L$(ANDROID_BUILD_TOP)/$(DEVICE_STRING)/DTV_OUT/shares_libraries \
                    -lmtal
endif

LOCAL_MODULE := lights.$(TARGET_BOARD_PLATFORM)
LOCAL_MODULE_TAGS := optional

include $(BUILD_SHARED_LIBRARY)
