# Copyright (C) 2011 The Android Open Source Project
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

LOCAL_PATH := $(call my-dir)

include $(CLEAR_VARS)

LOCAL_MODULE := set_wopacket_port
LOCAL_SRC_FILES := power.c
LOCAL_SHARED_LIBRARIES := liblog libiwpriv libcutils libnetutils
LOCAL_MODULE_TAGS := optional

DEVICE_STRING=device/$(CUSTOMER)/$(MODEL_NAME)
ANDROID_BUILD_TOP ?= .
export MTK_VMLINUX_ROOT := $(shell if [ -d $(TOP)/../../$(LINUX_ROOT_NAME) ]; then echo $(TOP)/../../$(LINUX_ROOT_NAME); fi)
ifeq "$(MTK_VMLINUX_ROOT)" ""
$(error MTK_VMLINUX_ROOT is not in $(TOP)/../../$(LINUX_ROOT_NAME))
endif

DTV_ROOT_OUTPUT ?= $(ANDROID_BUILD_TOP)/out/mediatek_linux/output

MY_C_INC := vendor/mediatek/open/public_inc/build/c_inc
MY_X_INC := vendor/mediatek/open/public_inc/build/x_inc

LOCAL_C_INCLUDES := vendor/mediatek/open/hardware/gralloc/libgralloc_t624
LOCAL_C_INCLUDES := vendor/mediatek/open/hardware/arm/mali-rel1/include

LOCAL_C_INCLUDES += \
    $(JNI_H_INCLUDE) \
    $(LOCAL_PATH) \
    $(LOCAL_PATH)/$(CUSTOM_PATH) \
    frameworks/base/include \
    system/core/include \
    vendor/mediatek/open/hardware/uploadservice/include

LOCAL_C_INCLUDES += \
    $(MY_C_INC) \
    $(MY_X_INC) \
    $(MTK_VMLINUX_ROOT)/custom/dev \
    $(MTK_VMLINUX_ROOT)/middleware/public \
    $(MTK_VMLINUX_ROOT)/middleware/public/svl \
    $(MTK_VMLINUX_ROOT)/middleware/public/inc \
    $(MTK_VMLINUX_ROOT)/middleware/public/cmpb \
	$(MTK_VMLINUX_ROOT)/custom/Sony/2K12/res \
	$(MTK_VMLINUX_ROOT)/custom/dev 


LOCAL_C_INCLUDES += $(ANDROID_BUILD_TOP)/hardware/libhardware_legacy/include

LOCAL_LDFLAGS += -L$(ANDROID_BUILD_TOP)/$(DEVICE_STRING)/DTV_OUT/shares_libraries \
#        -lapp_if_rpc \
#        -lrpc_ipc \
        -lhandle_app \
        -lcmpb \
        -ldtv_osai \
        -lmtal \
        -lapp_if
include $(BUILD_EXECUTABLE)

















