#include <stdio.h>
#include <sys/ioctl.h>
#include <stdlib.h>
#include <fcntl.h>
#include <time.h>
#include <errno.h>

#include <cutils/properties.h>

#include <android/log.h>
#define print_to_logcat(fmt...)\
__android_log_print(ANDROID_LOG_DEBUG, "UPDATE_LINUX", fmt);


int main(int argc, char** argv)
{
        FILE *fp = NULL;
        char dns1[PROPERTY_VALUE_MAX] = "";
        char dns2[PROPERTY_VALUE_MAX] = "";
        struct timespec ts, ts1;

        /* check to save logcat */
        if (property_get("net.dns1", dns1, "0") <= 0) 
        {
            dns1[0] = '\0';
        }

        if (property_get("net.dns2", dns2, "0") <= 0) 
        {
            dns2[0] = '\0';
        }
   

        ts.tv_nsec = 500000000;	// 500ms
        ts.tv_sec = 0; 
        nanosleep(&ts, &ts1);

        print_to_logcat("dns1=[%s],dns2=[%s]\n", dns1,dns2);

        printf("dns1=[%s],dns2=[%s]\n", dns1,dns2);

        fp = fopen ("/etc/resolv.conf","wb");
        if (fp != NULL)
        {
            if (dns1[0] != 0)
            {
                fprintf(fp,"nameserver %s\n",dns1);
            }
            if (dns2[1] != 0)
            {
                fprintf(fp,"nameserver %s\n",dns2);
            }
            fclose(fp);
        }
        else
        {
            print_to_logcat("Cannot open /etc/resolv.conf.\n");
        }

	return 0;
}
